<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_export.php                                         ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/tree.php");
	include($root_folder_path . "includes/record.php");


	check_admin_security("import_export");

	$errors = "";
	$rnd = get_param("rnd");
	$table = get_param("table");
	$csv_delimiter = get_param("csv_delimiter");
	$operation = get_param("operation");
	$category_id = get_param("category_id");
	$session_rnd = get_session("session_rnd");


  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_export.html");

	$t->set_var("admin_select_href", "admin_select.php");
	$t->set_var("admin_export_href", "admin_export.php");
	$t->set_var("admin_items_list_href", "admin_items_list.php");

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree");
	$tree->show($category_id);

	if ($table == "items") {
		include("./admin_table_items.php");
	} else if ($table == "categories") {
		include("./admin_table_categories.php");
	} else {
		$table_name = "";
		$table_title = "";
		$errors = "Can't find table to export.";
	}

	$t->set_var("table", $table);
	$t->set_var("table_title", $table_title);

	if($operation == "export")
	{
		if(!strlen($errors)) {
			$columns = array();
			$total_columns = get_param("total_columns");
			$columns_selected = 0;
			$columns_list = "";
			$csv_columns_list = "";
			for($col = 1; $col <= $total_columns; $col++) {
				$column_name = get_param("db_column_" . $col);
				if($column_name) {
					$columns_selected++;
					if($columns_selected > 1) {
						$columns_list .= ",";
						$csv_columns_list .= $csv_delimiter;
					}
					$csv_columns_list .= $db_columns[$column_name][0];
					$columns_list .= $column_name;
					$columns[] = $column_name;
				}
			}

			$csv_filename = $table_name . ".csv";
			header("Content-Type: application/x-ms-download"); 
			header("Content-Disposition: attachment; filename=" . $csv_filename); 
			header("Content-Transfer-Encoding: binary"); 
			header("Cache-Control: Public"); 

			echo $csv_columns_list . "\n";

			$sql = "SELECT " . $columns_list . " FROM " . $table_name;
			$db->query($sql);
			while ($db->next_record()) {
				$csv_row = "";
				for($i = 0; $i < $columns_selected; $i++) {
					$column_name = $columns[$i];
					$field_value = $db->f($column_name);
					if(preg_match("/[".$csv_delimiter."\"\n\r]/", $field_value)) {
						$field_value = "\"" . str_replace("\"", "\"\"", $field_value) . "\"";
					}
					if($i > 0) {
						$csv_row .= $csv_delimiter;
					}
					$csv_row .= $field_value;
				}
				echo $csv_row . "\n";
			}
			exit;
		}
	}


	if(strlen($errors))
	{
		$t->set_var("errors_list", $errors);
		$t->parse("errors", false);
	}
	else
	{
		$t->set_var("errors", "");
	}

	$t->set_var("category_id", $category_id);
	$t->set_var("rnd", time());

	$delimiters = array(array(",", "Comma"), array("\t", "Tab"), array(";", "Semicolon"));
	set_options($delimiters, $csv_delimiter, "delimiter");

	if ($table_name == ($table_prefix . "items") || $table_name == ($table_prefix . "categories")) {
		$t->parse("products_path", false);
	} else {
		$t->set_var("products_path", "");
	}

	$total_columns = 0;
	foreach($db_columns as $column_name => $column_info) {
		if($column_info[2] != HIDE_DB_FIELD) {
			$total_columns++;
			$db_columns_options[] = array($column_name, $column_info[0]);
			$t->set_var("col", $total_columns);
			$t->set_var("column_name", htmlspecialchars($column_name));
			$t->set_var("column_title", $column_info[0]);
			$t->parse("rows", true);
			if($total_columns % 2 == 0) {
				$t->parse("columns", true);
				$t->set_var("rows", "");
			}
		}
	}
	if($total_columns % 2 != 0) {
		$t->parse("columns", true);
	}

	$t->set_var("total_columns", $total_columns);

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");


?>