<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_import.php                                         ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/tree.php");
	include($root_folder_path . "includes/record.php");


	check_admin_security("import_export");

	$errors = "";
	$rnd = get_param("rnd");
	$table = get_param("table");
	$csv_delimiter = get_param("csv_delimiter");
	$operation = get_param("operation");
	$category_id = get_param("category_id");
	$use_first_row = get_param("use_first_row");
	$session_rnd = get_session("session_rnd");


  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_import.html");

	$t->set_var("admin_select_href", "admin_select.php");
	$t->set_var("admin_import_href", "admin_import.php");
	$t->set_var("admin_items_list_href", "admin_items_list.php");

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree");
	$tree->show($category_id);

	if ($table == "items") {
		include("./admin_table_items.php");
	} else if ($table == "categories") {
		include("./admin_table_categories.php");
	} else {
		$table_name = "";
		$table_title = "";
		$errors = "Can't find table to import.";
	}

	$db_columns_options = array();
	$db_columns_options[] = array("", "");
	$db_columns_options[] = array("-1", "<-- Ignore this column");
	if(!$errors) {
		foreach($db_columns as $column_name => $column_info) {
			if($column_info[2] != HIDE_DB_FIELD) {
				$db_columns_options[] = array($column_name, $column_info[0]);
			}
		}
		foreach($db_columns as $column_name => $column_info) {
			$column_title = strtolower($column_info[0]);
			$db_aliases[$column_title] = $column_name;
		}
	}

	$t->set_var("table", $table);
	$t->set_var("table_title", $table_title);

	if($operation == "upload")
	{
		if($HTTP_POST_FILES["csv_file"]["tmp_name"] == "none" || !strlen($HTTP_POST_FILES["csv_file"]["tmp_name"])) {
			$errors = "No file has been selected.";
		}

		if(!strlen($errors)) {
			//$filename = $HTTP_POST_FILES["csv_file"]["name"];
			$tmp_name = $HTTP_POST_FILES["csv_file"]["tmp_name"];
			$fp = fopen($tmp_name, "r");
			if(!$fp) {
				$errors = "Sorry can't open imported file. Please contact your administrator.";
			}
		}

		if(!strlen($errors)) {
			if ($columns_data = fgetcsv($fp, 4096, $csv_delimiter)) {
				$columns_number = sizeof($columns_data);
				if($columns_number < $min_column_allowed) {
					$errors = "Sorry at least " . $min_column_allowed . " columns are required. Please check your CSV file and settings you selected.";
				} 
			} else {
				$errors = "Sorry can't parse columns data. Please check your CSV file.";
			}
		}

		if(!strlen($errors)) {

			$operation = "import";
			$row = 1; $column_number = 0;
			for($i = 0; $i < $columns_number; $i++) {
				$column_number++;
				$column_title = $columns_data[$i];
				$db_column = strtolower($column_title);
				if(isset($db_aliases[$db_column])) {
					$db_column = $db_aliases[$db_column];
				}
				$field_name = "f_" . $row . "_" . $column_number;
				$t->set_var("field_name", $field_name);
				$t->set_var("field_value", htmlspecialchars($column_title));
				$t->set_var("column_number", $column_number);
				$t->set_var("column_title", htmlspecialchars($column_title));
				set_options($db_columns_options, $db_column, "db_column");
				$t->parse("columns", true);
				$t->parse("fields", true);
			}

			while ($data = fgetcsv($fp, 4096, $csv_delimiter)) {
				$row++;
				for($i = 0; $i < $columns_number; $i++) {
					$col = ($i + 1);
					$field_name = "f_" . $row . "_" . $col;
					$field_value = isset($data[$i]) ? $data[$i] : "";
					$t->set_var("field_name", $field_name);
					$t->set_var("field_value", htmlspecialchars($field_value));
					$t->parse("fields", true);
				}
				$t->set_var("row", $row);
				$t->parse("rows", true);
			}

			$t->set_var("total_rows", $row);
			$t->set_var("total_columns", $columns_number);
			fclose($fp);
		}
	} else if ($operation == "import") {
		$operation = "insert";
		$total_rows = get_param("total_rows");
		$total_columns = get_param("total_columns");
		$total_columns_left = $total_columns;
		$total_colspan = ($total_columns + 1);
		$total_errors = 0;
		$is_where = false;

		$r = new VA_Record($table_name);
		foreach($db_columns as $column_name => $column_info) {
			if ($column_info[2] == 1) {
				$where_column = $column_name;
				$r->add_where($column_name, $column_info[1], $column_info[0]);
			} else if($column_info[2] > 1 && $column_info[3] == true) {
				$r->add_textbox($column_name, $column_info[1], $column_info[0]);
				$r->change_property($column_name, REQUIRED, true);
				if(isset($column_info[4]) && strlen($column_info[4])) {
					$r->set_value($column_name, $column_info[4]);
					$r->change_property($column_name, USE_IN_UPDATE, false);
				}
			}
		}

		$column_number = 0;
		for($col = 1; $col <= $total_columns; $col++) {
			$column_name = get_param("db_column_" . $col);
			if($column_name == "-1" || $column_name == "") { // ignoring column
				$total_columns_left--;
			} else {
				$column_number++;
				if($db_columns[$column_name][2] == 1) {
					$is_where = true;
				} else {
					$r->add_textbox($column_name, $db_columns[$column_name][1], $db_columns[$column_name][0]);
					$r->change_property($column_name, USE_IN_UPDATE, true);
					if($db_columns[$column_name][3] == true) {
						$r->change_property($column_name, REQUIRED, true);
					}
				}
				$t->set_var("col", $column_number);
				$t->set_var("column_name", $column_name);
				$t->set_var("column_title", $db_columns[$column_name][0]);
				$t->parse("columns_titles", true);
			} 
		}
		$t->set_var("total_colspan", ($total_columns_left + 1));
		$t->set_var("total_rows", $total_rows);
		$t->set_var("total_columns", $total_columns_left);

		$start_row = $use_first_row ? 1 : 2;
		for($row = $start_row; $row <= $total_rows; $row++) {
			$t->set_var("cols", "");
			$column_number = 0;
			foreach($db_columns as $column_name => $column_info) {
				if($column_info[2] > 1 && $column_info[3] == true) {
					if(isset($column_info[4]) && strlen($column_info[4])) {
						$r->set_value($column_name, $column_info[4]);
					}
				}
			}
			for($col = 1; $col <= $total_columns; $col++) {
				$column_name = get_param("db_column_" . $col);
				if($column_name != "-1" && $column_name != "") { 
					$column_number++;
					$param_name = "f_" . $row . "_" . $col;
					$field_name = "f_" . $row . "_" . $column_number;
					$field_value = get_param($param_name);
					$strip_field_value = strip_tags($field_value);
					$short_field_value = (strlen($strip_field_value) > 30) ? substr($strip_field_value, 0, 30) . "..." : $strip_field_value;
					$column_name = get_param("db_column_" . $col);
					$r->set_value($column_name, $field_value);
					$t->set_var("field_name", $field_name);
					$t->set_var("field_value", htmlspecialchars($field_value));
					$t->set_var("short_field_value", htmlspecialchars($short_field_value));
			  
					$t->parse("cols", true);
					$t->parse("fields", true);
				}
			}
			$r->errors = "";
			$r->validate();
			if($r->errors) {
				$total_errors++;
				$t->set_var("status", "<font color=red>Error</font>");
				$t->set_var("error_value", "1");
				$t->set_var("row_class", "error");
				$t->set_var("errors_list", $r->errors);
				$t->parse("row_errors", false);
			} else {
				$is_exists = false;
				if($is_where) {
					$is_exists = $r->get_db_values();
				}
				$status = $is_exists ? "<font color=green>Exists</font>" : "<font color=blue>New</font>";
				$t->set_var("status", $status);
				$t->set_var("is_exists", intval($is_exists));
				$t->set_var("error_value", "0");
				$t->set_var("row_class", "usual");
				$t->set_var("row_errors", "");
			}

			$t->set_var("row", $row);
			$t->parse("rows", true);
		}

		$t->set_var("total_rowspan", ($total_rows + $total_errors + $use_first_row));
	} else if ($operation == "insert") {
		if($rnd != $session_rnd) {
			set_session("session_rnd", $rnd);
			$total_rows = get_param("total_rows");
			$total_columns = get_param("total_columns");

			$r = new VA_Record($table_name);
			foreach($db_columns as $column_name => $column_info) {
				if ($column_info[2] == 1) {
					$where_column = $column_name;
					$r->add_where($column_name, $column_info[1], $column_info[0]);
					$r->change_property($where_column, USE_IN_INSERT, true);
				} else if($column_info[2] > 1 && $column_info[3] == true) {
					$r->add_textbox($column_name, $column_info[1], $column_info[0]);
					$r->change_property($column_name, REQUIRED, true);
					if(isset($column_info[4]) && strlen($column_info[4])) {
						$r->set_value($column_name, $column_info[4]);
						$r->change_property($column_name, USE_IN_UPDATE, false);
					}
				}
			}
			$is_where = false;
			for($col = 1; $col <= $total_columns; $col++) {
				$column_name = get_param("db_column_" . $col);
				if($db_columns[$column_name][2] == 1) {
					$is_where = true;
				} else {
					$r->add_textbox($column_name, $db_columns[$column_name][1], $db_columns[$column_name][0]);
					$r->change_property($column_name, USE_IN_UPDATE, true);
				}
			}

			$records_error = 0;
			$records_added = 0;
			$records_updated = 0;
			$records_ignored = 0;

			$start_row = $use_first_row ? 1 : 2;
			for($row = $start_row; $row <= $total_rows; $row++) {

				$use_row = get_param("use_" . $row);
				$error_row = get_param("error_" . $row);
				if ($use_row == 1 && $error_row != 1) {
					$is_exists = get_param("is_exists_" . $row);

					$is_where_set = false;
					for($col = 1; $col <= $total_columns; $col++) {
						$field_name = "f_" . $row . "_" . $col;
						$field_value = get_param($field_name);
						$column_name = get_param("db_column_" . $col);
			  		if ($is_where && $where_column == $column_name && strlen($field_value)) {
							$is_where_set = true;
						}
						$r->set_value($column_name, $field_value);
					}
			  
					if($is_exists) {
						if ($r->update_record()) {
							$records_updated++;
						} else {
							$records_error++;
						}
					} else {
						if (!$is_where_set) {
							$sql = "SELECT MAX(" . $where_column . ") FROM " . $table_name . "";
							$db->query($sql);
							$db->next_record();
							$max_id = $db->f(0);
							$r->set_value($where_column, ($max_id + 1));
						} 
						if ($r->insert_record()) {
							$records_added++;
							$inserted_id = $r->get_value($where_column);
							if ($table_name == $table_prefix . "items") {
								$sql  = " INSERT INTO " . $table_prefix . "items_categories (item_id, category_id) ";
								$sql .= " VALUES (" . $db->tosql($inserted_id, INTEGER) . ", " . $db->tosql($category_id, INTEGER) . ") ";
								$db->query($sql);
							}
						} else {
							$records_error++;
						}
					} 
				} else {
					$records_ignored++;
				}
			}
			set_session("session_records_error", $records_error);
			set_session("session_records_added", $records_added);
			set_session("session_records_updated", $records_updated);
			set_session("session_records_ignored", $records_ignored);

			$operation = "result";
		} else {
			$records_error = get_session("session_records_error");
			$records_added = get_session("session_records_added");
			$records_updated = get_session("session_records_updated");
			$records_ignored = get_session("session_records_ignored");

			$operation = "result";
		}
		if($records_error > 0) {
			$t->set_var("records_error", $records_error);	
			$t->parse("db_errors", $records_error);	
		}
		$t->set_var("records_added", $records_added);
		$t->set_var("records_updated", $records_updated);
		$t->set_var("records_ignored", $records_ignored);
	}

	if(strlen($errors))
	{
		//$t->set_var("after_upload", "");
		$t->set_var("errors_list", $errors);
		$t->parse("errors", false);
	}
	else
	{
		$t->set_var("errors", "");
	}

	$t->set_var("operation", $operation);
	$t->set_var("category_id", $category_id);
	$t->set_var("use_first_row", $use_first_row);
	$t->set_var("rnd", time());

	$t->set_var("import_block", "");
	$t->set_var("insert_block", "");
	$t->set_var("upload_block", "");
	$t->set_var("result_block", "");
	if ($operation == "import") {
		$t->parse("import_block", false);
	} else if ($operation == "insert") {
		$t->parse("insert_block", false);
	} else if ($operation == "result") {
		$t->parse("result_block", false);
	} else {
		$operation = "upload";
		$delimiters = array(array(",", "Comma"), array("\t", "Tab"), array(";", "Semicolon"));
		set_options($delimiters, $csv_delimiter, "delimiter");
		$t->parse("upload_block", false);
	}

	if ($table_name == ($table_prefix . "items") || $table_name == ($table_prefix . "categories")) {
		$t->parse("products_path", false);
	} else {
		$t->set_var("products_path", "");
	}


	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");


?>