<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_layout_page.php                                    ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("layouts");

	$return_page = "admin_layouts.php";
	$layout_id = get_param("layout_id");
	$page_name = get_param("page_name");

	$sql = "SELECT layout_name FROM " . $table_prefix . "layouts WHERE layout_id=" . $db->tosql($layout_id, INTEGER);
	$db->query($sql);
	if($db->next_record() && strlen($page_name)) {
		$layout_name = $db->f("layout_name");
	} else {
		header("Location: " . $return_page);
		exit;
	}

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main", "admin_layout_page.html");
  $t->set_var("layout_name", $layout_name);

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_layouts_href", "admin_layouts.php");
	$t->set_var("admin_layout_href", "admin_layout.php");
	$t->set_var("admin_layout_page_href", "admin_layout_page.php");

	$r = new VA_Record($table_prefix . "page_settings");

	$columns_values = 
		array( 
			array(1, 1), array(2, 2), array(3, 3),
			array(4, 4), array(5, 5), array(6, 6)
			);

	$categories_types = 
		array( 
			array(1, "One-Level list with short description"), 
			array(2, "Two-Level list with subcategories"),
			array(3, "Multiple-Level list with all available categories")
			);

	$subs = 
		array( 
			array(0, "All"),
			array(1, 1), array(2, 2), array(3, 3),
			array(4, 4), array(5, 5), array(6, 6),
			array(7, 4), array(8, 5), array(9, 6)
			);
	
	$records_per_page = 
		array( 
			array(5, 5), array(10, 10), array(15, 15),
			array(20, 20), array(25, 25), array(50, 50),
			array(75, 75), array(100, 100)
			);

	$r->add_select("categories_type", TEXT, $categories_types);
	$r->add_select("categories_columns", TEXT, $columns_values);
	$r->add_select("categories_subs", TEXT, $subs);
	if($page_name == "index" || $page_name == "products") {
		$r->add_select("products_columns", TEXT, $columns_values);
		$r->add_select("products_per_page", TEXT, $records_per_page);
	}
	$r->add_textbox("left_column_width", TEXT, "Left Column Width");
	$r->add_textbox("middle_column_width", TEXT, "Middle Column Width");
	$r->add_textbox("right_column_width", TEXT, "Right Column Width");
	$r->add_checkbox("left_column_hide", TEXT);
	$r->add_checkbox("middle_column_hide", TEXT);
	$r->add_checkbox("right_column_hide", TEXT);


	if($page_name == "index") {
		$blocks = array(
			"top_products_block" => "Top Rating Products",
			"search_block" => "Search Form",
			"login_block" => "Login Form",
			"cart_block" => "Small Cart",
			"categories_block" => "Categories List",
			"offers_block" => "Products Special Offers",
			"events_block" => "Events",
			"news_block" => "News"
		);
	} else if ($page_name == "products") {
		$blocks = array(
			"top_products_block" => "Top Rating Products",
			"search_block" => "Search Form",
			"login_block" => "Login Form",
			"cart_block" => "Small Cart",
			"category_description_block" => "Category Description",
			"categories_block" => "Categories List",
			"products_block" => "Products List"
		);
	} else if ($page_name == "details") {
		$blocks = array(
			"top_products_block" => "Top Rating Products",
			"search_block" => "Search Form",
			"login_block" => "Login Form",
			"cart_block" => "Small Cart",
			"category_description_block" => "Category Description",
			"categories_block" => "Categories List",
			"details_block" => "Product/Reviews Details"
		);
	}

	$sql = " SELECT * FROM " . $table_prefix . "custom_blocks ";
	$db->query($sql);
	while($db->next_record()) {
		$block_id = $db->f("block_id");
		$block_title = $db->f("block_title");
		if(!$block_title) {
			$block_title = $db->f("block_desc");
		}
		$block_title = strip_tags($block_title);
		$words = explode(" ", $block_title);
		if(sizeof($words) > 3) {
			$block_title = "";
			for ($i = 0; $i < 3; $i++) {
				$block_title .= $words[$i] . " ";
			}
			$block_title .= " ...";
		} 

		$blocks["custom_block_" . $block_id] = $block_title;
	}

	

	$left_blocks = array();
	$middle_blocks = array();
	$right_blocks = array();
	$available_blocks = array();

	$r->get_form_parameters();

	$operation = get_param("operation");

	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		$available_list = get_param("available_list");
		$left_list = get_param("left_list");
		$middle_list = get_param("middle_list");
		$right_list = get_param("right_list");
		if($available_list) {
			$available_array = split(",", $available_list);
			for($i = 0; $i < sizeof($available_array); $i++) {
				$available_blocks[] = array($available_array[$i], $blocks[$available_array[$i]]);
			}
		}
		if($left_list) {
			if($r->get_value("left_column_hide") == 0) {
				$r->parameters["left_column_width"][REQUIRED] = true;
			}
			$left_array = split(",", $left_list);
			for($i = 0; $i < sizeof($left_array); $i++) {
				$left_blocks[] = array($left_array[$i], $blocks[$left_array[$i]]);
			}
		}
		if($middle_list) {
			if($r->get_value("middle_column_hide") == 0) {
				$r->parameters["middle_column_width"][REQUIRED] = true;
			}
			$middle_array = split(",", $middle_list);
			for($i = 0; $i < sizeof($middle_array); $i++) {
				$middle_blocks[] = array($middle_array[$i], $blocks[$middle_array[$i]]);
			}
		}
		if($right_list) {
			if($r->get_value("right_column_hide") == 0) {
				$r->parameters["right_column_width"][REQUIRED] = true;
			}
			$right_array = split(",", $right_list);
			for($i = 0; $i < sizeof($right_array); $i++) {
				$right_blocks[] = array($right_array[$i], $blocks[$right_array[$i]]);
			}
		}

		$r->validate();

		if(!strlen($r->errors))
		{
			set_session("session_" . $page_name .  "_settings", "");

			$sql  = " DELETE FROM " . $table_prefix . "page_settings WHERE layout_id=" . $db->tosql($layout_id, INTEGER);
			$sql .= " AND page_name=" . $db->tosql($page_name, TEXT);;
			$db->query($sql);
			foreach($r->parameters as $key => $value)
			{
				$sql  = " INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_value) VALUES (";
				$sql .= $db->tosql($layout_id, INTEGER) . ",";
				$sql .= $db->tosql($page_name, TEXT) . ",";
				$sql .= $db->tosql($key, TEXT) . ",";
				$sql .= $db->tosql($value[CONTROL_VALUE], TEXT) . ")";
				$db->query($sql);
			}
			for($i = 0; $i < sizeof($left_blocks); $i++) {
				$sql  = " INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (";
				$sql .= $db->tosql($layout_id, INTEGER) . ",";
				$sql .= $db->tosql($page_name, TEXT) . ",";
				$sql .= $db->tosql($left_blocks[$i][0], TEXT) . "," . $i . ",'left')";
				$db->query($sql);
			}
			for($i = 0; $i < sizeof($middle_blocks); $i++) {
				$sql  = " INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (";
				$sql .= $db->tosql($layout_id, INTEGER) . ",";
				$sql .= $db->tosql($page_name, TEXT) . ",";
				$sql .= $db->tosql($middle_blocks[$i][0], TEXT) . "," . $i . ",'middle')";
				$db->query($sql);
			}
			for($i = 0; $i < sizeof($right_blocks); $i++) {
				$sql  = " INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (";
				$sql .= $db->tosql($layout_id, INTEGER) . ",";
				$sql .= $db->tosql($page_name, TEXT) . ",";
				$sql .= $db->tosql($right_blocks[$i][0], TEXT) . "," . $i . ",'right')";
				$db->query($sql);
			}

			header("Location: " . $return_page);
			exit;
		}
	}
	else 
	{
		$sql  = " SELECT setting_name,setting_value FROM " . $table_prefix . "page_settings ";
		$sql .= " WHERE layout_id=" . $db->tosql($layout_id, INTEGER);
		$sql .= " AND page_name=" . $db->tosql($page_name, TEXT);
		$sql .= " ORDER BY setting_order ";
		$db->query($sql);
		while ($db->next_record()) {
			$setting_name = $db->f("setting_name");
			$setting_value = $db->f("setting_value");
			if(isset($blocks[$setting_name])) {
			  if($setting_value == "left") {
					$left_blocks[] = array($setting_name, $blocks[$setting_name]);
					$left_blocks_values[$setting_name] = $setting_value;
				} else if($setting_value == "middle") {
					$middle_blocks[] = array($setting_name, $blocks[$setting_name]);
					$middle_blocks_values[$setting_name] = $setting_value;
				} else if($setting_value == "right") {
					$right_blocks[] = array($setting_name, $blocks[$setting_name]);
					$right_blocks_values[$setting_name] = $setting_value;
				}
			} else if (isset($r->parameters[$setting_name])) {
				$r->set_value($setting_name, $setting_value);
			}
		}

		foreach($blocks as $block_name => $block_title)
		{
			if(!isset($left_blocks_values[$block_name]) && 
				!isset($middle_blocks_values[$block_name]) && 
				!isset($right_blocks_values[$block_name])) {
				$available_blocks[] = array($block_name, $block_title);
			}
		}

	}


	$r->set_form_parameters();
	if($page_name == "index") {
		$t->set_var("page_name_desc", "Home");
		$t->parse("offers_settings", false);
	} else if($page_name == "products") {
		$t->set_var("page_name_desc", "Categories & Products");
		$t->parse("products_settings", false);
	} else if($page_name == "details") {
		$t->set_var("page_name_desc", "Detailed");
	}


	set_options($available_blocks, "", "available_blocks");
	set_options($left_blocks, "", "left_blocks");
	set_options($middle_blocks, "", "middle_blocks");
	set_options($right_blocks, "", "right_blocks");
	
	$t->set_var("layout_id", htmlspecialchars($layout_id));
	$t->set_var("page_name", htmlspecialchars($page_name));

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>