<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_orders.php                                         ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/sorter.php");
	include($root_folder_path . "includes/navigator.php");
	include($root_folder_path . "includes/date_functions.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("sales_orders");

	$currency_left = ""; $currency_right = "";
	if($settings["currency_position"] == 1)
		$currency_left = $settings["currency_sign"];
	else if($settings["currency_position"] == 2)
		$currency_right = $settings["currency_sign"];

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_orders.html");

	$t->set_var("admin_orders_href", "admin_orders.php");
	$t->set_var("admin_order_href", "admin_order.php");
	$t->set_var("admin_href", "admin.php");

	$s = new VA_Sorter($settings["admin_templates_dir"], "sorter_img.html", "admin_orders.php");
	$s->set_default_sorting(1, "desc");
	$s->set_sorter("No", "sorter_id", "1", "order_id");
	$s->set_sorter("Order Placed", "sorter_date", "2", "order_placed_date");
	$s->set_sorter("Status", "sorter_status", "3", "order_status");
	$s->set_sorter("Total", "sorter_total", "4", "goods_total");

	$n = new VA_Navigator($settings["admin_templates_dir"], "navigator.html", "admin_orders.php");

	include("./admin_header.php");
	include("./admin_footer.php");

	$order_statuses = get_db_values("SELECT * FROM " . $table_prefix . "order_statuses", array(array("", "Any")));

	$where = "";
	$r = new VA_Record($table_prefix . "orders");
	$r->add_textbox("s_w", TEXT);
	$r->add_radio("s_s", INTEGER, $order_statuses);
	$r->get_form_parameters();
	$r->set_form_parameters();
	$t->set_var("s_w_url", urlencode($r->get_value("s_w")));
	$t->set_var("s_s_url", urlencode($r->get_value("s_s")));

	if(!$r->is_empty("s_w")) {
		$s_w_sql = $db->tosql($r->get_value("s_w"), TEXT, false);
		$where  = " (o.order_id LIKE '%" . $s_w_sql . "%'";
		$where .= " OR o.email LIKE '%" . $s_w_sql . "%'";
		$where .= " OR o.name LIKE '%" . $s_w_sql . "%'";
		$where .= " OR o.first_name LIKE '%" . $s_w_sql . "%'";
		$where .= " OR o.last_name LIKE '%" . $s_w_sql . "%')";
	}

	if(!$r->is_empty("s_s")) {
		if(strlen($where)) { $where .= " AND "; }
		$where .= " o.order_status=" . $db->tosql($r->get_value("s_s"), INTEGER);
	}

	$where_count = ""; $where_sql = "";
	if(strlen($where)) {
		$where_count = " WHERE " . $where;
		$where_sql   = " AND " . $where;
	}

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "orders o " . $where_count);
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;

	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$sql  = " SELECT o.order_id, o.order_placed_date, os.status_name, o.goods_total, ";
	$sql .= " o.name, o.first_name, o.last_name ";
	$sql .= " FROM " . $table_prefix . "orders o, " . $table_prefix . "order_statuses os ";
	$sql .= " WHERE o.order_status=os.status_id ";
	$db->query($sql . $where_sql . $s->order_by);
	if($db->next_record())
	{
		$t->parse("sorters", false);
		$t->set_var("no_records", "");
		do
		{
			$t->set_var("order_id", $db->f("order_id"));
			$user_name = $db->f("name");
			if(!strlen($user_name)) {
				$user_name = $db->f("first_name") . " " . $db->f("last_name");
			}
			$t->set_var("user_name", $user_name);

			$placed_date = $db->f("order_placed_date", DATETIME);
			$t->set_var("order_placed_date", va_date($datetime_show_format, $placed_date));

			$t->set_var("order_status", $db->f("status_name"));
			$t->set_var("goods_total", $currency_left . number_format($db->f("goods_total"), 2) . $currency_right);
			$t->parse("records", true);
		} while($db->next_record());
	}
	else
	{
		$t->set_var("sorters", "");
		$t->set_var("records", "");
		$t->set_var("navigator", "");
		$t->parse("no_records", false);
	}

	$t->pparse("main");

?>