<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  article.php                                              ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/tree.php");
	include($root_folder_path . "includes/date_functions.php");

	check_admin_security("articles_categories");

	$today = date("Y.m.d");
	
	$category_id = get_param("category_id");
	if(!strlen($category_id)) $category_id = "0";

	$content_types = 
		array( 
			array(1, "HTML"), array(0, "Plain Text")
		);

  	$t = new VA_Template($settings["admin_templates_dir"]);
  	$t->set_file("main","article.html");

	$t->set_var("article_href", "article.php");
	$t->set_var("articles_upload_href", "articles_upload.php");
	$t->set_var("articles_select_href", "articles_select.php");
	$t->set_var("articles_list_href", "articles_list.php");

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "articles_categories", "tree");
	$tree->show($category_id);

	$r = new VA_Record($table_prefix . "articles");

	$r->add_where("article_id", INTEGER);
	$r->change_property("article_id", USE_IN_INSERT, true);
	$r->add_hidden("category_id", INTEGER);
	
	//Common info
	$r->add_textbox("article_title", TEXT, "Article Title");
	$r->change_property("article_title", REQUIRED, true);
	$r->change_property("article_title", MAX_LENGTH, 255);
	$r->add_textbox("article_order", INTEGER, "Article Order");
	$r->change_property("article_order", REQUIRED, true);
	$r->add_textbox("article_date", DATETIME, "Article Date");
	$r->change_property("article_date", REQUIRED, true);
	$r->change_property("article_date", VALUE_MASK, $date_edit_format);
	$r->add_textbox("language_code", TEXT, "Language Code");
	$r->change_property("language_code", MAX_LENGTH, 2);
	$r->add_textbox("article_template", TEXT, "Article Template");
	$r->change_property("article_template", MAX_LENGTH, 255);
	
	//Author
	$r->add_textbox("author_name", TEXT, "Author Name");
	$r->change_property("author_name", REQUIRED, true);
	$r->change_property("author_name", MAX_LENGTH, 255);
	$r->add_textbox("author_email", TEXT, "Author Email");
	$r->change_property("author_email", MAX_LENGTH, 255);
	$r->change_property("author_email", REGEXP_MASK, EMAIL_REGEXP);
	$r->add_textbox("author_url", TEXT, "Author URL");
	$r->change_property("author_url", MAX_LENGTH, 255);
	$r->add_textbox("author_remote_address", TEXT, "Author Remote Address");
	$r->change_property("author_remote_address", MAX_LENGTH, 255);
	
	//Others Authors
	$users = get_db_values("SELECT * FROM " . $table_prefix . "users", array(array("", "None")));
	$r->add_select("created_user_id", INTEGER, $users);
	$r->add_select("updated_user_id", INTEGER, $users, "Last user who edited the article");
	$admins = get_db_values("SELECT * FROM " . $table_prefix . "admins", array(array("", "None")));
	$r->add_select("created_admin_id", INTEGER, $admins);
	$r->add_select("updated_admin_id", INTEGER, $admins);
	
	//Statuses
	$statuses = get_db_values("SELECT * FROM " . $table_prefix . "articles_statuses", array(array("", "None")));
	$r->add_select("status_id", INTEGER, $statuses);
	$r->add_checkbox("is_html", INTEGER, "Article is in HTML");
	$values_list = array(array("0", "Nobody"), array("1", "All"), array("2", "Registered"));
	$r->add_select("allowed_view", INTEGER, $values_list, "Allow view articles");
	$r->add_checkbox("allowed_ratings", INTEGER, "Allow rate articles");
	$r->add_checkbox("is_hot", INTEGER, "Show on main page");
	
	//Links
	$r->add_textbox("link_url", TEXT, "Link URL");
	$r->add_textbox("download_url", TEXT, "Download URL");
	$r->add_textbox("is_link_direct", TEXT, "Link is direct");
	
	//Dates
	$r->add_textbox("date_added", TEXT, "Article add date");
	$r->add_textbox("date_updated", TEXT, "Article update date");	
	
	//Descriptions
	$r->add_textbox("keywords", TEXT, "Article Keywords");
	$r->add_textbox("hot_description", TEXT, "Article Hot Description");
	$r->add_textbox("short_description", TEXT, "Article Short Description");
	$r->add_textbox("full_description", TEXT, "Article Full Description");
	$r->add_textbox("notes", TEXT, "Article Notes");
	
	//Statistics
	$r->add_textbox("total_viewed", INTEGER, "Total Views");
	$r->add_textbox("total_votes", INTEGER, "Total Votes");
	$r->add_textbox("total_points", INTEGER, "Rating");
	$r->add_textbox("total_clicks", INTEGER, "Total Clicks");
	
	//Images
	$r->add_textbox("image_small", TEXT, "Small Image");
	$r->add_textbox("image_large", TEXT, "Large Image");
		
	$r->get_form_values();

	$article_id = get_param("article_id");
	$operation = get_param("operation");
	$return_page = "articles_list.php?category_id=" . $category_id;
	if($r->get_value("downloadable")) {
		$r->parameters["download_period"][REQUIRED] = true;
		$r->parameters["download_path"][REQUIRED] = true;		
	}

	if(strlen($operation))
	{
		if($operation == "cancel") {
			header("Location: " . $return_page);
			exit;
		} //cancel
		else if($operation == "delete" && $article_id) {			
			$categories = "";
			$sql  = " SELECT category_id FROM " . $table_prefix . "articles_assigned ";
			$sql .= " WHERE article_id = " . $db->tosql($article_id, INTEGER);
			$db->query($sql);
			while($db->next_record()) $categories[] = $db->f("category_id");
			if(is_array($categories)) {
				for($i = 0; $i < sizeof($categories); $i++) {
					$db->query("UPDATE " . $table_prefix . "articles_categories SET total_articles = total_articles - 1 WHERE category_id = " . $db->tosql($categories[$i], INTEGER));
				}
			}
			// tables with article_id: articles, articles_assigned, articles_related, articles_images, articles_reviews
			$db->query("DELETE FROM " . $table_prefix . "articles_assigned WHERE article_id = " . $db->tosql($article_id, INTEGER));
			$db->query("DELETE FROM " . $table_prefix . "articles_related WHERE article_id = " . $db->tosql($article_id, INTEGER));
			$db->query("DELETE FROM " . $table_prefix . "articles_images WHERE article_id = " . $db->tosql($article_id, INTEGER));
			$db->query("DELETE FROM " . $table_prefix . "articles_reviews WHERE article_id = " . $db->tosql($article_id, INTEGER));
			$db->query("DELETE FROM " . $table_prefix . "articles WHERE article_id = " . $db->tosql($article_id, INTEGER));
			
			header("Location: " . $return_page);
			exit;
		} //delete

		$is_valid = $r->validate();
		
		if($is_valid) {
			if(strlen($article_id)) {
				$r->set_value("date_updated", $today);
				$r->update_record();
			}
			else {
				$db->query("SELECT MAX(article_id) FROM " . $table_prefix . "articles");
				$db->next_record();
				$article_id = $db->f(0) + 1;
				$r->set_value("article_id", $article_id);
				$r->set_value("total_viewed", 0);
				$r->set_value("total_votes", 0);
				$r->set_value("total_points", 0);
				$r->set_value("total_clicks", 0);
				$r->set_value("date_added", $today);
				$r->set_value("date_updated", $today);
				$r->insert_record();
				$sql  = " INSERT INTO " . $table_prefix . "articles_assigned (article_id, category_id) VALUES (";
				$sql .= $db->tosql($article_id, INTEGER) . ",";
				$sql .= $db->tosql($category_id, INTEGER) . ")";
				$db->query($sql);
				$db->query("UPDATE " . $table_prefix . "articles_categories SET total_articles = total_articles + 1 WHERE category_id = " . $category_id);
			}
	
			header("Location: " . $return_page);
			exit;
		}
	}
	else if(strlen($article_id)) {
		$r->get_db_values();
	}
	//new record
	else {
		$sql  = " SELECT MAX(article_order) FROM " . $table_prefix . "articles a, " . $table_prefix . "articles_assigned aa ";
		$sql .= " WHERE a.article_id = aa.article_id ";
		$sql .= " AND aa.category_id = " . $db->tosql($category_id, INTEGER);
		$article_order = get_db_value($sql);
		$article_order = ($article_order) ? ($article_order + 1) : 1;
		$r->set_value("article_order", $article_order);
	}

	$r->set_form_parameters();

	if(strlen($article_id))	
	{
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else
	{
		$t->set_var("save_button", "Add Article");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>