<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  articles_categories.php                                  ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/tree.php");

	check_admin_security("articles_categories");

	$article_id = get_param("article_id");

  	$t = new VA_Template($settings["admin_templates_dir"]);
  	$t->set_file("main","articles_categories.html");

	$t->set_var("articles_categories_href", "articles_categories.php");
	$t->set_var("articles_list_href", "articles_list.php");
	$t->set_var("article_href", "article.php");

	$sql  = " SELECT article_title FROM " . $table_prefix . "articles ";
	$sql .= " WHERE article_id = " . $db->tosql($article_id, INTEGER);
	$db->query($sql);
	if($db->next_record())
		$t->set_var("article_title", $db->f("article_title"));
	else
		die("Article with such ID no longer exists in database.");

	$category_id = get_param("category_id");
	if(!strlen($category_id)) $category_id = "0";

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "articles_categories", "tree");
	$tree->show($category_id);

	$operation = get_param("operation");
	$return_page = "articles_list.php?category_id=" . $category_id;
	$errors = "";

	if($operation == "cancel")
	{
		header("Location: " . $return_page);
		exit;
	}
	else if($operation == "save")
	{
		$categories = get_param("categories");
		if(!strlen($categories))
			$errors .= "No categories was selected.<br>";
		
		if(!strlen($errors))
		{
			$categories = split(",", $categories);
			$db->query("DELETE FROM " . $table_prefix . "articles_assigned WHERE article_id = " . $article_id);
			for($i = 0; $i < sizeof($categories); $i++)
				$db->query("INSERT INTO " . $table_prefix . "articles_assigned (article_id, category_id) VALUES (" . $article_id . "," . $db->tosql($categories[$i], INTEGER) . ")");
	
			header("Location: " . $return_page);
			exit;
		}
	}

	$sql = " SELECT category_id, parent_category_id, category_name FROM " . $table_prefix . "articles_categories ORDER BY category_path";
	$db->query($sql);
	while($db->next_record())
	{
		$t->set_var("category_id", $db->f("category_id"));
		$t->set_var("parent_category_id", $db->f("parent_category_id"));
		$t->set_var("category_name", str_replace("\"", "&qout;", $db->f("category_name")));
		$t->parse("categories");
	}

	$sql = " SELECT category_id FROM " . $table_prefix . "articles_assigned WHERE article_id = " . $article_id;
	$db->query($sql);
	while($db->next_record())
	{
		$t->set_var("category_id", $db->f("category_id"));
		$t->parse("selected_categories");
	}

	if(strlen($errors))
	{
		$t->set_var("errors_list", $errors);
		$t->parse("errors", false);
	}
	else
	{
		$t->set_var("errors", "");
	}

	$t->set_var("article_id", $article_id);
	$t->set_var("category_id", $category_id);
	$t->set_var("selected_name", "selected[]");

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>