<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  articles_categories_order.php                            ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/tree.php");

	check_admin_security("articles_categories");

  	$t = new VA_Template($settings["admin_templates_dir"]);
  	$t->set_file("main", "articles_categories_order.html");
  	$t->set_var("articles_list_href", "articles_list.php");
  	$t->set_var("articles_categories_order_href", "articles_categories_order.php");

	$parent_category_id = get_param("parent_category_id");
	if(!$parent_category_id) $parent_category_id = 0;

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "articles_categories", "tree");
	$tree->show($parent_category_id);

	$available_categories = array();
	$shown_categories_all = array();
	$shown_categories_reg = array();

	$operation = get_param("operation");
	$return_page = "articles_list.php?category_id=" . $parent_category_id;

	if(strlen($operation)) {
		if($operation == "cancel") {
			header("Location: " . $return_page);
			exit;
		}
		$available_list = get_param("available_list");
		$shown_all_list = get_param("shown_all_list");
		$shown_reg_list = get_param("shown_reg_list");
		if($available_list) {
			$available_array = split(",", $available_list);
			for($i = 0; $i < sizeof($available_array); $i++) {
				$available_categories[] = array($available_array[$i], $categories[$available_array[$i]]);
			}
		}
		if($shown_all_list) {
			$shown_all_array = split(",", $shown_all_list);
			for($i = 0; $i < sizeof($shown_all_array); $i++) {
				$shown_categories_all[] = array($shown_all_array[$i], $categories[$shown_all_array[$i]]);
			}
		}
		if($shown_reg_list) {
			$shown_reg_array = split(",", $shown_reg_list);
			for($i = 0; $i < sizeof($shown_reg_array); $i++) {
				$shown_categories_reg[] = array($shown_reg_array[$i], $categories[$shown_reg_array[$i]]);
			}
		}

		if($operation == "save") {
			for($i = 0; $i < sizeof($shown_categories_all); $i++) {
				$sql  = " UPDATE " . $table_prefix . "articles_categories SET category_order = " . intval($i + 1);
				$sql .= " , allowed_view = 1 ";
				$sql .= " WHERE category_id = " . $shown_categories_all[$i][0];
				$db->query($sql);
			}
			for($j = 0; $j < sizeof($shown_categories_reg); $j++) {
				$sql  = " UPDATE " . $table_prefix . "articles_categories SET category_order = " . intval($i + $j + 1);
				$sql .= " , allowed_view = 2 ";
				$sql .= " WHERE category_id = " . $shown_categories_reg[$j][0];
				$db->query($sql);
			}
			for($k = 0; $k < sizeof($available_categories); $k++) {
				$sql  = " UPDATE " . $table_prefix . "articles_categories SET category_order = " . intval($i + $j + $k + 1);
				$sql .= " , allowed_view = 0 ";
				$sql .= " WHERE category_id = " . $available_categories[$k][0];
				$db->query($sql);
			}
			header("Location: " . $return_page);
			exit;
		}
	}
	else {
		$sql  = " SELECT category_id, category_name, allowed_view ";
		$sql .= " FROM " . $table_prefix . "articles_categories WHERE parent_category_id = " . $db->tosql($parent_category_id, INTEGER);
		$sql .= " ORDER BY category_order, category_id DESC ";
		$db->query($sql);
		while($db->next_record())
		{
			$category_id = $db->f("category_id");
			$category_order = $db->f("category_order");
			$category_name = $db->f("category_name");
			$allowed_view = $db->f("allowed_view");
			if ($allowed_view == 1) {
				$shown_categories_all[] = array($category_id, $category_name);
			} elseif ($allowed_view == 2) {
				$shown_categories_reg[] = array($category_id, $category_name);
			} else $available_categories[] = array($category_id, $category_name);
		}
	}

	set_options($available_categories, "", "available_categories");
	set_options($shown_categories_all, "", "shown_categories_all");
	set_options($shown_categories_reg, "", "shown_categories_reg");

	$t->set_var("errors", "");
	$t->set_var("parent_category_id", $parent_category_id);

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>