<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  block_categories_list.php                                ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


function categories($block_name)
{
	global $t;
	global $db, $table_prefix;
	global $category_id;
	global $page_settings;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$columns = get_setting_value($page_settings, "categories_columns", 1);
	$categories_type = get_setting_value($page_settings, "categories_type");

	if(!isset($category_id) || !strlen($category_id)) { $category_id = get_param("category_id"); }

	$search_category_id = get_param("search_category_id");
	$search_string = get_param("search_string");
	$is_search = strlen($search_string);
  
	if($is_search) $category_id = $search_category_id;
	if(!strlen($category_id)) $category_id = "0";

	$t->set_var("products_href", "products.php");
	$t->set_var("CATEGORIES_TITLE", CATEGORIES_TITLE);
	$t->set_var("MORE_MSG",         MORE_MSG);
	$t->set_var("READ_MORE_MSG",    READ_MORE_MSG);
	$t->set_var("CLICK_HERE_MSG",   CLICK_HERE_MSG);
	$t->set_var("TOP_CATEGORY_MSG", TOP_CATEGORY_MSG);

	if ($categories_type == 2) 
	{
		$show_tree = false;
    $t->set_file("block_body", "block_categories_catalog.html");
  
		// show categories as catalog
		$sql  = " SELECT c.category_id as top_category_id,c.category_name as top_category_name, c.image, ";
		$sql .= " s.category_id as sub_category_id,s.category_name as sub_category_name ";
		$sql .= " FROM " . $table_prefix . "categories c ";
		$sql .= " LEFT JOIN " . $table_prefix . "categories s ON c.category_id=s.parent_category_id ";
		$sql .= " WHERE c.parent_category_id=" . $db->tosql($category_id, INTEGER);
		$sql .= " AND c.is_showing=1";
		$sql .= " ORDER BY c.category_order, c.category_id, s.category_order ";

		$db->query($sql);
		if($db->next_record())
		{
			$category_number = 0;
			$is_subcategories = true;
			$shown_sub_categories = get_setting_value($page_settings, "categories_subs"); 
			$catalog_top_number = 0;
			$catalog_sub_number = 0;
			$column_width = intval(90 / $columns);
			$t->set_var("column_width", $column_width . "%");
			do
			{
				$category_number++;
				$catalog_sub_number++;
				$top_category_id = $db->f("top_category_id");
				$t->set_var("catalog_top_id", $top_category_id);
				$t->set_var("catalog_top_name", $db->f("top_category_name"));
				$t->set_var("catalog_sub_id", $db->f("sub_category_id"));
				$t->set_var("catalog_sub_name", $db->f("sub_category_name"));
  
				$category_image = $db->f("image");
				$category_name = $db->f("top_category_name");
 
				$is_next_record = $db->next_record();
				$is_new_top = ($top_category_id != $db->f("top_category_id"));
  
				if($shown_sub_categories >= $catalog_sub_number || !$shown_sub_categories)
				{
					if($is_next_record && !$is_new_top)
						$t->parse("catalog_sub_separator", false);
					else
						$t->set_var("catalog_sub_separator", "");
					$t->parse("catalog_sub", true);
				} else if(($shown_sub_categories + 1) == $catalog_sub_number) {
					$t->parse("catalog_sub_more", false);
				}
  
				if($is_next_record)
				{
					if($is_new_top)
					{
						$catalog_top_number++;

						if($category_image && file_exists($category_image))
						{
              $image_size = @GetImageSize($category_image);
              $t->set_var("alt", htmlspecialchars($category_name));
              $t->set_var("src", htmlspecialchars($category_image));
							if(is_array($image_size)) {
		            $t->set_var("width", "width=\"" . $image_size[0] . "\"");
    	          $t->set_var("height", "height=\"" . $image_size[1] . "\"");
							} else {
		            $t->set_var("width", "");
    	          $t->set_var("height", "");
							}
							$t->parse("catalog_image", false);
						} else {
							$t->set_var("catalog_image", "");
						}

						$t->parse("catalog_top");
						$t->set_var("catalog_sub", "");
						$t->set_var("catalog_sub_more", "");
						if($catalog_top_number % $columns == 0)
						{
							$t->parse("catalog_rows");
							$t->set_var("catalog_top", "");
						}
						$catalog_sub_number = 0;
					} 
				}
				else
				{
					$t->parse("catalog_top");
					$t->parse("catalog_rows");
				}
  
			} while ($is_next_record);
  
			if($show_tree)
			{
				$catalog_tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "catalog_tree", TOP_CATEGORY_MSG);
				$catalog_tree->show($category_id);
			} else {
			  $t->parse("catalog_title", false);
			}	
  
			$t->parse("block_body", false);
			$t->parse($block_name, true);
		}

	} else { // list type 

		$show_tree = false;
  
    $t->set_file("block_body", "block_categories_list.html");
  
		//$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree");
		//$tree->show($category_id);
  
		$sql  = " SELECT category_id,category_name,short_description,image ";
		$sql .= " FROM " . $table_prefix . "categories ";
		$sql .= " WHERE is_showing=1";
		if ($categories_type == 1) {
			$sql .= " AND parent_category_id = " . $db->tosql($category_id, INTEGER);
		}
		$sql .= " ORDER BY category_order ";
		$db->query($sql);
		if($db->next_record())
		{
			$is_subcategories = true;
			$category_number = 0;
			$column_width = intval(90 / $columns);
			$t->set_var("column_width", $column_width . "%");
			do
			{
				$category_number++;
				$show_category_id  = $db->f("category_id");
				$category_name  = $db->f("category_name");
				$category_image = $db->f("image");
				$t->set_var("category_id", $show_category_id);
				$t->set_var("category_name", $category_name);
				if($category_image && file_exists($category_image))
				{
          $image_size = @GetImageSize($category_image);
          $t->set_var("alt", htmlspecialchars($category_name));
          $t->set_var("src", htmlspecialchars($category_image));
					if(is_array($image_size))
					{
		        $t->set_var("width", "width=\"" . $image_size[0] . "\"");
    	      $t->set_var("height", "height=\"" . $image_size[1] . "\"");
					}
					else
					{
		        $t->set_var("width", "");
    	      $t->set_var("height", "");
					}
					$t->parse("category_image", false);
				}
				else
				{
					$t->set_var("category_image", "");
				}
				$t->set_var("short_description", $db->f("short_description"));
				$t->parse("categories");
				if($category_number % $columns == 0)
				{
					$t->parse("categories_rows");
					$t->set_var("categories", "");
				}
			} while ($db->next_record());
			if($category_number % $columns != 0)
				$t->parse("categories_rows");
  
			if($show_tree)
			{
				$categories_tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "categories_tree");
				$categories_tree->show($category_id);
			} else {
			  $t->parse("categories_title", false);
			}	
  
			$t->parse("block_body", false);
			$t->parse($block_name, true);
		}

	}


}

?>