<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  db_mysql.php                                             ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


class VA_SQL {
  
  var $DBHost         = "";
  var $DBPort         = "";
  var $DBDatabase     = "";
  var $DBUser         = "";
  var $DBPassword     = "";
  var $DBPersistent   = false;

	/* dates formats */
	var $DatetimeMask   = array("YYYY","-","MM","-","DD"," ","HH",":","mm",":","ss");
	var $DateMask       = array("YYYY","-","MM","-","DD");
	var $TimeMask       = array("HH",":","mm",":","ss");
	var $TimestampMask  = array("YYYY","MM","DD","HH","mm","ss");

  var $AutoFree       = 0;     
  var $LinkID         = 0;
  var $QueryID        = 0;
  var $PageNumber     = 0;
  var $RecordsPerPage = 0;
  var $Record         = array();
  var $Row            = 0;

  var $Errno       = 0;
  var $Error       = "";
  var $HaltOnError = "yes"; // "yes", "no", "report"


  function VA_SQL($query = "") {
		$this->RecordsPerPage = 0;
    $this->query($query);
  }

  function connect() {
    if (!$this->LinkID) {
	    if($this->DBPort != "") $this->DBHost .= ":" . $this->DBPort;
	    
      if($this->DBPersistent)
        $this->LinkID = @mysql_pconnect($this->DBHost, $this->DBUser, $this->DBPassword);
      else
        $this->LinkID = @mysql_connect($this->DBHost, $this->DBUser, $this->DBPassword);

      if (!$this->LinkID) {
        $this->halt("Connect failed.");
        return 0;
      }

      if (!@mysql_select_db($this->DBDatabase,$this->LinkID)) {
				$this->LinkID = 0;
        $this->halt("Cannot use database " . $this->DBDatabase);
        return 0;
      }
    }
    
    return $this->LinkID;
  }

  function free() {
      @mysql_free_result($this->QueryID);
      $this->QueryID = 0;
  }

  function query($Query_String) {
    if ($Query_String == "") {
      return 0;
		}

    if (!$this->connect()) {
      return 0; 
    };

    if ($this->QueryID) {
      $this->free();
    }

		if ($this->RecordsPerPage && $this->PageNumber) {
			$Query_String .= " LIMIT " . (($this->PageNumber - 1) * $this->RecordsPerPage) . ", " . $this->RecordsPerPage;
			$this->RecordsPerPage = 0;
			$this->PageNumber = 0;
		}

    $this->QueryID = @mysql_query($Query_String,$this->LinkID);
    $this->Row   = 0;
    $this->Errno = mysql_errno();
    $this->Error = mysql_error();
    if (!$this->QueryID) {
      $this->halt("Invalid SQL: ".$Query_String);
    }

    return $this->QueryID;
  }

  function next_record() {
    if (!$this->QueryID) {
      $this->halt("next_record called with no query pending.");
      return 0;
    }

    $this->Record = @mysql_fetch_array($this->QueryID);
    $this->Row   += 1;
    $this->Errno  = mysql_errno();
    $this->Error  = mysql_error();

    $stat = is_array($this->Record);
    if (!$stat && $this->AutoFree) {
      $this->free();
    }
    return $stat;
  }

  function seek($pos = 0) {
    $status = @mysql_data_seek($this->QueryID, $pos);
    if ($status)
      $this->Row = $pos;
    else {
      $this->halt("seek($pos) failed: result has " . $this->num_rows() . " rows");

      @mysql_data_seek($this->QueryID, $this->num_rows());
      $this->Row = $this->num_rows;
      return 0;
    }

    return 1;
  }

  function affected_rows() {
    return @mysql_affected_rows($this->LinkID);
  }

  function num_rows() {
    return @mysql_num_rows($this->QueryID);
  }

  function num_fields() {
    return @mysql_num_fields($this->QueryID);
  }

  function f($Name, $field_type = TEXT) 
	{
    if(isset($this->Record[$Name]))
		{
			$value = $this->Record[$Name];
			switch($field_type)
			{
				case DATETIME:
					$value = parse_date($this->DatetimeMask, $value);
					break;
				case DATE:
					$value = parse_date($this->DateMask, $value);
					break;
				case TIME:
					$value = parse_date($this->TimeMask, $value);
					break;
			}
      return $value; 
		}
    else 
      return "";
  }

  function halt($message) {

    if ($this->HaltOnError == "no")
      return;

		print "<b>Database error:</b> " . $message . "<br>\n";
		print "<b>MySQL Error Code:</b> " . $this->Errno . "<br>\n";
		print "<b>MySQL Error Message:</b> " . $this->Error . "<br>\n";

    if ($this->HaltOnError != "report")
      die("Session halted.");
  }

	function tosql($value, $value_type, $is_delimiters = true, $use_null = true)
	{
    if(is_array($value) || strlen($value)) 
		{
			switch($value_type)
			{
				case NUMBER:
				case FLOAT:
	        return doubleval(str_replace("," , ".", $value));
					break;
				case TEXT:
					$value = addslashes($value);
					break;
				case DATETIME:
					if(!is_array($value) && is_int($value)) { $value = va_time($value); }
					if(is_array($value)) { $value = va_date($this->DatetimeMask, $value); }
					else { return "NULL"; }
					break;
				case INTEGER:
	        return intval($value);
					break;
				case DATE:
					if(!is_array($value) && is_int($value)) { $value = va_time($value); }
					if(is_array($value)) { $value = va_date($this->DateMask, $value); }
					else { return "NULL"; }
					break;
				case TIME:
					if(!is_array($value) && is_int($value)) { $value = va_time($value); }
					if(is_array($value)) { $value = va_date($this->TimeMask, $value); }
					else { return "NULL"; }
					break;
				case TIMESTAMP:
					if(!is_array($value) && is_int($value)) { $value = va_time($value); }
					if(is_array($value)) { $value = va_date($this->TimestampMask, $value); }
					else { return "NULL"; }
					break;
			}
			if($is_delimiters) {
				$value = "'" . $value . "'";
			}
		} 
		else if($use_null) 
		{
			$value = "NULL";
		} 
		else 
		{
			if($value_type == INTEGER || $value_type == FLOAT || $value_type == NUMBER) {
				$value = 0;
			} else if ($is_delimiters) {
				$value = "''";
			}
		} 
		return $value;
	}

}
?>